



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Swift3.0服务端开发(二) 静态文件添加、路由配置以及表单提交</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Swift3.0服务端开发(二) 静态文件添加、路由配置以及表单提交</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-26 08:29:26 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>今天博客中就来聊一下Perfect框架的静态文件的添加与访问，路由的配置以及表单的提交。虽然官网上有聊静态文件的访问的部分，但是在使用Perfect框架来访问静态文件时还是有些点需要注意的，这些关键点在其官方文档上并未提出。今天我们要做的事情就是通过浏览器访问静态文件，然后在静态文件中使用form表单往指定的路由上进行提交相应的数据。</p>
<p><strong>一、静态文件的添加与访问</strong></p>
<p><strong>1、未使用Xcode管理的Perfect的静态文件根目录的配置</strong></p>
<p>在PHP开发或者Java Web开发中，都有一个根目录来存储相应的静态文件，比如wwwroot, htdoc, webroot等等这些文件。在使用Perfect开发服务器端时，亦是如此，我们可以在Source目录中的main.swift中对静态文件的根目录进行配置，下方就是我们的配置代码：</p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/545446/201612/545446-20161212102419511-611385237.png"></p>
<p>配置完成后，如果我们的项目不是用Xcode进行管理的话，当我们对Perfect工程进行编译和运行时，会在相应的模板目录下创建相应的静态文件的根目录（webroot）。如下所示：</p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/545446/201612/545446-20161212103538183-1562854308.png"></p>
<p>在webroot中我们添加上相应的静态文件，我们就可以通过Perfect服务进行访问了，下方是我们在webroot中添加的index.html的内容，用浏览器就可以访问了。下方就是我们比较简单的index.html中的内容了，当然下方的html简单的不能在简单了，如下所示：</p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/545446/201612/545446-20161212104100636-205151165.png"></p>
<p>在访问上述index.html文件之前，我们需要将main.swift中添加的路由进行删除，下方选中的部分就是要删除的代码。如果你不删除下方这段代码的话，如果你访问localhost:8181的话，那么就是下方路由所返回的内容。修改完代码后，要重新进行编译运行才生效的，这一点与解释性语言PHP是不同的。</p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/545446/201612/545446-20161212104213995-1895352295.png"></p>
<p>经过上述步骤后，我们就可以通过访问localhost:8181来加载我们的index.html文件了，如下所示：</p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/545446/201612/545446-20161212104518136-1228021212.png"></p>
<p><strong>2、Xcode管理下的Perfect的静态文件目录</strong></p>
<p>上述步骤是未使用Xcode管理Perfect项目的情况，webroot文件夹就位于工程目录下。当我们的Perfect工程使用Xcode进行管理后，webroot的位置就会被改变。下方就是调用swift的包管理器生成相应的xcodeproj文件：</p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/545446/201612/545446-20161212105239761-1392418302.png"></p>
<p>如果你的项目目录中有webroot目录，也有index.html文件。但是使用xcode进行Perfect项目管理后，就找不到下方这个index.html文件了。也就是webroot的文件目录变地方了。这一点在官方文档上是没有介绍的。</p>
<p>　　　　<img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/545446/201612/545446-20161212110948714-912984003.png"></p>
<p>通过搜索，我们可以找到Xcode管理下的Perfect项目中的webroot目录，使用Xcode打开Perfect工程，找到Product，然后右键单击，Show In Finder。</p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/545446/201612/545446-20161212111559714-1111437354.png"></p>
<p>我们会看到Xcode管理下的webroot目录，如下所示。你可以将静态文件放到wwwroot中进行访问。</p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/545446/201612/545446-20161212111719464-824876134.png"></p>
<p>当我们在此刷新浏览器时，就可以找到相应的index.html.</p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/545446/201612/545446-20161212111910495-306942368.png"></p>
<p><strong>二、路由配置</strong></p>
<p>下方这段代码就是main.swift中的代码段，首先创建了一个HTTPServer()的对象，然后又创建了一个路由对象，接着又将这个路由对象添加到了服务对象上。具体代码如下所示：</p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/545446/201612/545446-20161212114153792-1486998133.png"></p>
<p><strong>1.添加静态路由路径</strong></p>
<p>我们可以通过调用routes对象的add()方法为路由添加各种路径，当然add()有好多重载的方法，不过其功能都是往路由上添加路径、请求方法或者创立句柄。</p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/545446/201612/545446-20161212142112323-861933826.png"></p>
<p>下方我们添加了一个“/login”的路由路径，其请求方法是.get的方式。后方的尾随闭包是对响应的处理。具体代码如下:</p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/545446/201612/545446-20161212142813011-601270236.png"></p>
<p>重新编译并运行我们的Perfect工程，然后访问localhost:8181/login路径，会在浏览器中看到下方的返回信息。其他的路由</p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/545446/201612/545446-20161212143247823-2082897897.png"></p>
<p><strong>2、路由变量</strong></p>
<p>在配置路由时，我们的路径中可以添加路由变量来匹配同一类型的url。下方就是Perfect框架中路由变量的使用。在URL中通过{key}的方式来插入路由变量。下方的uri中中间的{\(valueKey)}就是通过字符串插值的方式插入的路由变量的Key，我们可以通过这个key来获取到相应的路由变量。</p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/545446/201612/545446-20161212144119558-1286096462.png"></p>
<p>下方就是我们访问上述路径的结果：</p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/545446/201612/545446-20161212144430058-808855589.png"></p>
<p><strong>3、路由通配符</strong></p>
<p>我们还可以在URI中使用通配符类匹配路径，使用*好来匹配通用的路径。下方就是路由通配符的使用方式：</p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/545446/201612/545446-20161212144833245-2036529274.png"></p>
<p>下方就是路由通配符是运行结果：</p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/545446/201612/545446-20161212145012073-1587281965.png"></p>
<p><strong>4.结尾通配符</strong></p>
<p>下方就是结尾通配符的使用方式，结尾处使用“**”来匹配尾部所有符合规则的uri, 然后通过routeTrailingWildcardKey来获取通配的内容。</p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/545446/201612/545446-20161212145256917-1914583749.png"></p>
<p>访问结果如下所示：</p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/545446/201612/545446-20161212145433886-441290931.png"></p>
<p>上述这四种路由的优先级为：路由变量 &gt; 静态路由 &gt; 通配符路径 &gt; 结尾通配符。官方文档上还有如果配置路由表的版本的示例，在此就不做过多赘述了。</p>
<p><strong>&nbsp;</strong></p>
<p><strong>三、表单提交与Json返回</strong></p>
<p>聊完路由的配置，接下来我们要聊一下表单的提交与json数据的返回。本部分内容我们首先使用form表单post提交的方式将数据提交到指定的路由并处理，处理完毕后再讲处理的数据通过josn的数据格式返回给客户端。</p>
<p><strong>1、构建form表单</strong></p>
<p>首先我们得创建相应的表单提交的代码，当然代码比较简单，就一个from表单。action的地址就是我们在服务器端配置的路由地址“127.0.0.1:8181/login”，而表单提交的方式是POST。具体如下所示。</p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/545446/201612/545446-20161212151621417-461811576.png"></p>
<p><strong>2、获取form表单参数</strong></p>
<p>下方就是服务器端获取表单参数的代码。首先我们添加了一个“/login”路由，路由的请求方式是.post。首先我们获取请求的参数。因为form表单的请求参数名是“userName”和“password”，所以我们要使用这两个name从request对象中获取相应的值。获取到值后你可以查询数据库或者其他一些操作呢。操作完毕后返回相应的json信息。Swift中的字典是可以调用jsonEncodeString()方法来转换的，后边的博客会对部分Perfect框架的源码进行解析，其中会涉及到如何将字典转换成json串，在此就不做过多赘述了。</p>
<p>　　<img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/545446/201612/545446-20161212152250933-1835273415.png"></p>
<p><strong>3.表单提交与结果返回</strong></p>
<p>上面web页和服务端都已实现完毕，接下来我们就开始测试了。下方就是相应的form表单与结果返回：</p>
<p>　　　<img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/545446/201612/545446-20161212153054026-825512385.png"></p>
<p>本篇博客就先到这儿，下篇博客仍然会对Perfect框架的相关内容进行介绍。</p>
<p>p.p1 { margin: 0.0px 0.0px 0.0px 0.0px; font: 14.0px "PingFang SC"; color: #4bd156 }<br />
span.s1 { }<br />
span.s2 { font: 14.0px Menlo }</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxlgv0q.html">hdfs中block的使用情况，副本所在情况等等</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8odzjeq.html">非递归创建二叉树（ C&plus;&plus;队列 ）</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qngwxk8.html">SAS实验室之PROC TRANSPOSE</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql46409.html">注意Activator&period;CreateInstance两个重载方法的性能</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx76dd9.html">&lbrack;模仿&rsqb;&lbrack;JS&rsqb;新浪财经7&ast;24直播</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zrxk59.html">&lbrack;AIR&rsqb; Screen 的应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v1mym8.html">Android端如何获取手机当前的网络状态&comma;比如wifi还是3G&comma; 还是2G&comma; 电信还是联通&comma;还是移动</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1wyvr9.html">如何使代码审查更高效【摘自InfoQ】</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgdned8.html">从注册流程 分析如何安全退出多个Activity 多种方式（附DEMO）</a>
		</li>
						<li><a href="https://www.batexi.com/a/95025o08.html">&lbrack;Swift&rsqb;LeetCode37&period; 解数独 &vert; Sudoku Solver</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj743lq.html">《Effective C&plus;&plus;》模板与泛型编程：条款32-条款40</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjv5k59.html">编程菜鸟的日记-初学尝试编程-C&plus;&plus; Primer Plus 第4章编程练习9</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy4er39.html">ASP&period;NET WebApi服务接口如何防止重复请求实现HTTP幂等性</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gddn6q.html">Visual Studio中配置Beyond Compare为版本比较工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdz23z9.html">Pandas基础知识（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5wl3rq.html">Linux的命名空间详解--Linux进程的管理与调度（二）【转】</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlldex6q.html">&num;14  &lbrack;BZOJ2090&sol;2089&rsqb; &lbrack;Poi2010&rsqb;Monotonicity 2&sol;Monotonicity</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx25r5z8.html">Ubuntu下Eclipse热键Ctrl&plus;Alt&plus;Up无效的解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1724x9.html">Hex-Rays Decompiler</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ko7v05q.html">UITableView的UITableViewStyleGrouped</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qdpwd7zq.html">讲故事的人写的谈判手册&mdash;&mdash;Leo锦书64</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1krlk49.html">正则提取文本中的颜色值 &num;xxxx，不严谨版本</a>
			</li>
						<li><a href="https://www.batexi.com/a/8oj1glpq.html">SQL点滴13&mdash;收集SQLServer线程等待信息</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2j5yex8.html">mysql查询字段值为数字</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gejxde8.html">Linux根目录下文件说明</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zj6vj9.html">SufaceView（绘图类）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gejk178.html">&lbrack;转&rsqb;【Android】9-patch图片以及例子说明</a>
			</li>
						<li><a href="https://www.batexi.com/a/950gy3m8.html">初识Identity</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdwy2y9.html">XHTML</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2j5lgl8.html">Backbone&period;js的技巧和模式</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
